#include <algorithm>
#include <cassert>
#include <format>
#include <iostream>
#include <numeric>
#include <random>

#include "simulateur.h"

using namespace std;

const vector<strategie_t> strategie_joueuses{
    strategie_t::kCarte_la_plus_petite,      strategie_t::kCarte_la_plus_petite,
    strategie_t::kCarte_au_milieu_main,     strategie_t::kCarte_au_milieu_main,
    strategie_t::kCarte_random,     strategie_t::kCarte_random,
    strategie_t::kCarte_avant_la_plus_grande, strategie_t::kCarte_avant_la_plus_grande,
    strategie_t::kCarte_la_plus_grande,       strategie_t::kCarte_la_plus_grande};

void choisir_carte(Joueuse j) { // TODO 4 bis : Decidez si j est passé en copie, en référence ou en référence constante.
  // Fixe @a j.carte_pour_ce_tour en fonction de @a j.strategie.
  // TODO 10
  switch (j.strategie) {
    using enum strategie_t;
  case kCarte_la_plus_petite:

    break;
  case kCarte_au_milieu_main:

    break;
  case kCarte_random: {
    static random_device rd;
    static default_random_engine gen(rd());
    uniform_int_distribution distrib(0, static_cast<int>(j.main.size() - 1));

    break;
  }
  case kCarte_avant_la_plus_grande:

    break;
  case kCarte_la_plus_grande:

    break;
  default:
    assert(false);
  }
  // Supprime @a j.carte_pour_ce_tour de @a j.main.
  // TODO 10 (suite)

}

void dump_cartes(const cartes_t &cartes) {
  // TODO 1 bis

  cout << endl;
}

int get_nb_vaches(int carte) {
  if (carte / 10 == carte % 10) {
    // La carte est un doublet (11, 22, etc.).
    return carte == 55 ? 7 : 5;
  }
  if (carte % 10 == 0) {
    // La carte finit par 0.
    return 3;
  }
  if (carte % 5 == 0) {
    // La carte finit par 5.
    return 2;
  }
  // La carte est une carte standard.
  return 1;
}

int get_nb_vaches(const cartes_t& cartes) {
  // TODO 9

  return -1;
}

std::string_view get_nom_strategie(strategie_t strategie) {
  // Methode de conversion recommandee en https://www.learncpp.com/cpp-tutorial/converting-an-enumeration-to-and-from-a-string/
  using enum strategie_t;
  switch (strategie) {
  case kCarte_la_plus_petite:
    return "Carte la plus petite";
  case kCarte_au_milieu_main:
    return "Carte au milieu de la main";
  case kCarte_random:
    return "Carte random";
  case kCarte_avant_la_plus_grande:
    return "Carte avant la plus grande";
  case kCarte_la_plus_grande:
    return "Carte la plus grande";
  default:
    return "??? Strategie inconnue ???";
  }
}

size_t get_rang_ou_jouer(const Joueuse& j, const rangees_t& rangees) {
  // TODO 11

  return -1;
}

void jouer_carte(Joueuse j, rangees_t rangees) { // TODO 6 ter : Decidez si j et rangees sont passés en copie, en référence ou en référence constante.
  size_t rang_ou_jouer{get_rang_ou_jouer(j, rangees)};

  // TODO 12
}

void simuler_partie(statistiques_t& stat) {
  static_assert(kNb_joueuses * kNb_initial_cartes_en_main + kNb_rangees <=
         kNb_total_cartes);

  //
  // Initialisations
  // 

  // Definit et initialise @a tas_cartes_initial.
  // TODO 1


  // Pour chaque joueuse de @a joueuse, initialise sa strategie joueuses et sa main
  // (la 1ere joueuse recoit les 10 premieres cartes de @a tas_cartes_initial,
  // la 2eme les 10 suivantes...) en n'oubliant pas de trier sa main.
  vector<Joueuse> joueuses(kNb_joueuses);
  assert(joueuses.size() <= strategie_joueuses.size());
  // TODO 2

  // Initialise rangees.
  rangees_t rangees(kNb_rangees);
  // TODO 3


  //
  // Simulation des tours de jeu.
  //
  for (size_t tour = 1; tour <= kNb_initial_cartes_en_main; ++tour) {
    // Chaque joueuse choisit sa carte.
    // TODO 4


    // Trie @a joueuses de la plus petite à la plus grande carte_pour_ce_tour.
    // TODO 5


    // Chaque joueuse joue sa carte.
    // TODO 6


    // Affiche la main des differentes joueuses et les cartes dans chaque rangee.
    // TODO 7

  }

  //
  // Fin de partie : 
  // - Trier joueuses par ordre croissant de nb_vaches_encaissees
  // - Afficher resultats
  // - Mettre a jour @p stat
  //

  // TODO 8

}

